<?php
require_once("Conexion.php");
class ClaseBase
{
	protected $id, $tabla;

	public function setId($id)
	{
		$this->id = $id;
	}

	public function getId()
	{
		return $this->id;
	}

	public function setTabla($tabla)
	{
		$this->tabla=$tabla;
	}

	public function getTabla()
	{
		return $this->tabla;
	}

	public function getAll()
	{
		$con = Conexion::getInstance();
		$sql = "SELECT * FROM $this->tabla ORDER BY id ASC";
		$result = $con->db->prepare($sql);
		$result->execute();
		$data = $result->fetchAll();
		return $data;
	}

	public function getById($id)
	{
		$con = Conexion::getInstance();
		$sql = "SELECT * FROM $this->tabla WHERE id=:id";
		$result = $con->db->prepare($sql);
		$params = array ("id"=>$id);
		$result->execute($params);
		$data = $result->fetchAll();
		return $data;
	}

	public function deleteById($id)
	{
		$con = Conexion::getInstance();
		$sql = "DELETE FROM $this->tabla WHERE id=:id";
		$result = $con->db->prepare($sql);
		$params = array ("id"=>$id);
		$borra = $result->execute($params);
		return $borra;
	}

	public function contarAll()
	{
		$con = Conexion::getInstance();
		$sql = "SELECT COUNT(*) FROM $this->tabla";
		$result = $con->db->prepare($sql);
		$params = array ("tabla"=>$tabla);
		$cant = $result->execute($params);
		$datos = $cant->fetchAll();
		return $datos;
	}

	public function pagina_actual()
	{
		return isset($_GET['p']) ? (int)$_GET['p']: 1;	
	}

	public function numero_paginas($post_por_pagina)
	{
		$con = Conexion::getInstance();
		$total_post = $con->db->prepare('SELECT FOUND_ROWS() as total');
		$total_post->execute();
		$total_post = $total_post->fetch()['total'];
		$numero_paginas = ceil($total_post / $post_por_pagina);
		return $numero_paginas;
	}

	//-------Lista dependiente de sector y parroquia------------

	
	public function Sector()
	{
	//Función para cargar el sector
		$con = Conexion::getInstance();
		$sql = "SELECT * FROM sector WHERE codigo_parroquia = $this->id";
		$result = $con->db->prepare($sql);
		$result->execute();
		$datos = $result->fetchAll();
		return $datos;
	}

	public function Material()
	{
	//Función para cargar el materialdeportivo
		$con = Conexion::getInstance();
		$sql = "SELECT * FROM materialdeportivo";
		$result = $con->db->prepare($sql);
		$result->execute();
		$datos = $result->fetchAll();
		return $datos;
	}

	public function Categoria()
	{
	//Función para cargar la categoria
		$con = Conexion::getInstance();
		$sql = "SELECT * FROM categoria WHERE codigo_dis = $this->id";
		$result = $con->db->prepare($sql);
		$result->execute();
		$datos = $result->fetchAll();
		return $datos;
	}
}
?>