<?php
require_once("../Config/ClaseBase.php");
require_once("Persona.php");
require_once("Institucion.php");
require_once("../Config/Conexion.php");

class Evento extends Institucion
{
	protected $codigo_even, $nombre_even, $fechaI, $fechaF, $hora_inicio, $hora_fin, $impacto, $codigo_res, $nom_res, $telefono_contacto, $codigo_sec, $cedula_usu;

	private $codigo_per_eve;

	public function __construct($tab)
	{
		ClaseBase::setTabla($tab);
	}

	public function setCodigo_even($codigo_even){
		$this->codigo_even=$codigo_even;
	}

	public function getCodigo_even(){
		return $this->codigo_even;
	}

	public function setNombre_even($nombre_even){
		$this->nombre_even=$nombre_even;
	}
	public function getNombre_even(){
		return $this->nombre_even;
	}

	public function setFechaI($fechaI){
		$this->fechaI=$fechaI;
	}
	public function getFechaI(){
		return $this->fechaI;
	}

	public function setFechaF($fechaF){
		$this->fechaF=$fechaF;
	}
	public function getFechaF(){
		return $this->fechaF;
	}

	public function setImpacto($impacto){
		$this->impacto=$impacto;
	}
	public function getImpacto(){
		return $this->impacto;
	}

	public function setParticipantes($participantes){
		$this->participantes=$participantes;
	}
	public function getParticipantes(){
		return $this->participantes;
	}

	public function setCedula_usu($cedula_usu){
		$this->cedula_usu=$cedula_usu;
	}

	public function getCedula_usu(){
		return $this->cedula_usu;
	}

	public function setCodigo_sec($codigo_sec){
		$this->codigo_sec = $codigo_sec;
	}

	public function getCodigo_sec(){
		return $this->codigo_sec;
	}

	public function setCodigo_dis($codigo_dis){
		$this->codigo_dis = $codigo_dis;
	}

	public function getCodigo_dis(){
		return $this->codigo_dis;
	}

	public function setCodigo_per_eve($codigo_per_eve){
		$this->codigo_per_eve = $codigo_per_eve;
	}

	public function guardarEvento()
	{
		$con=Conexion::getInstance();
		$sql="INSERT INTO $this->tabla(`codigo_even`, `nombre_even`, `impacto`, `fechaI`, `fechaF`, `codigo_sec`, `codigo_dis`, `cedula_usu`, `codigo_ins`) VALUES (NULL,'$this->nombre_even', '$this->impacto', '$this->fechaI', '$this->fechaF', '$this->codigo_sec', '$this->codigo_dis', '$this->cedula_usu', '$this->codigo_ins')";
		$result = $con->db->prepare($sql);
		$insert = $result->execute();
		return $insert;
	}

	public function modificarEvento($codigo_even)
	{
		$con = Conexion::getInstance();
		$sql="UPDATE $this->tabla SET nombre_even='$this->nombre_even', fechaI='$this->fechaI', fechaF='$this->fechaF', impacto='$this->impacto', codigo_res='$this->codigo_res', nom_res='$this->nom_res', telefono_contacto='$this->telefono_contacto', participantes='$this->participantes', codigo_sec='$this->codigo_sec' WHERE codigo_even=:codigo_even";
		$result = $con->db->prepare($sql);
		$params = array ("codigo_even"=>$codigo_even);
		$cambio = $result->execute($params);
		return $cambio;
	}

	public function getAll()
	{
		$con = Conexion::getInstance();
		$sql = "SELECT * FROM $this->tabla INNER JOIN disciplina on evento.codigo_dis=disciplina.codigo_dis ORDER BY codigo_even ASC";
		$result = $con->db->prepare($sql);
		$result->execute();
		$data = $result->fetchAll();
		return $data;
	}

	public function getById($codigo_even)
	{
		$con = Conexion::getInstance();
		$sql = "SELECT * FROM $this->tabla INNER JOIN disciplina on evento.codigo_dis=disciplina.codigo_dis WHERE codigo_even=:codigo_even";
		$result = $con->db->prepare($sql);
		$params = array ("codigo_even"=>$codigo_even);
		$result->execute($params);
		$data = $result->fetchAll();
		return $data;
	}

	public function deleteById($codigo_even)
	{
		$con = Conexion::getInstance();
		$sql = "DELETE FROM $this->tabla WHERE codigo_even=:codigo_even";
		$result = $con->db->prepare($sql);
		$params = array ("codigo_even"=>$codigo_even);
		$borra = $result->execute($params);
		return $borra; 
	}

	public function getEvento($post_por_pagina)
	{
		$con = Conexion::getInstance();
		$inicio = (self::pagina_actual() > 1) ? self::pagina_actual() * $post_por_pagina - $post_por_pagina: 0;
		$sql = "SELECT SQL_CALC_FOUND_ROWS * FROM $this->tabla INNER JOIN disciplina on evento.codigo_dis=disciplina.codigo_dis ORDER BY codigo_even ASC LIMIT $inicio, $post_por_pagina";
		$result = $con->db->prepare($sql);
		$result->execute();
		$data = $result->fetchAll();
		return $data;
	}

	public function anadirPersonas()
	{
		$con = Conexion::getInstance();
		$sql = "INSERT INTO persona_evento (`codigo_per_eve`, `cedula`, `codigo_even`) VALUES 
		(NULL,'$this->cedula','$this->codigo_even')";
		$result = $con->db->prepare($sql);
		$insert = $result->execute();
		return $insert;
	}

	public function Personas()
	{//Función para cargar la persona
		$con = Conexion::getInstance();
		$sql = "SELECT * FROM persona ORDER BY cedula";
		$result = $con->db->prepare($sql);
		$result->execute();
		$datos = $result->fetchAll();
		return $datos;		
	}

	public function Institucion()
	{//Función para cargar la persona
		$con = Conexion::getInstance();
		$sql = "SELECT * FROM institucion ORDER BY codigo_ins";
		$result = $con->db->prepare($sql);
		$result->execute();
		$datos = $result->fetchAll();
		return $datos;		
	}

	public function buscarEvento(){
		$con= Conexion::getInstance();
		$id= $_POST['busqueda'];
		$sql= 'SELECT * FROM evento INNER JOIN disciplina on evento.codigo_dis=disciplina.codigo_dis WHERE nombre_even LIKE :doc';
		$stmt= $con->db->prepare($sql);
		$result= $stmt->execute(array(':doc'=>"%$id%"));
		$rows = $stmt->fetchAll(\PDO::FETCH_OBJ);
		return $rows;
	}

	public function getByDisciplina($codigo_dis)
	{
		$con = Conexion::getInstance();
		$sql = "SELECT * FROM $this->tabla WHERE codigo_dis=:codigo_dis";
		$result = $con->db->prepare($sql);
		$params = array ("codigo_dis"=>$codigo_dis);
		$result->execute($params);
		$data = $result->fetchAll();
		return $data;
	}

}
?>