<?php
require_once("Usuario.php");

class Institucion extends Usuario
{
	protected $codigo_ins, $nombre_ins;

	public function __construct($tab)
	{
		ClaseBase::setTabla($tab);
	}

	public function setNombre_ins($nombre_ins)
	{
		$this->nombre_ins = $nombre_ins;
	}

	public function getNombre_ins()
	{
		return $this->nombre_ins;
	}
	
	public function setCodigo_ins($codigo_ins)
	{
		$this->codigo_ins = $codigo_ins;
	}

	public function getCodigo_ins()
	{
		return $this->codigo_ins;
	}

	public function guardarInstitucion()
	{
		$con=Conexion::getInstance();
		$sql="INSERT INTO $this->tabla (codigo_ins, nombre_ins) VALUES (NULL,'$this->nombre_ins')";
		$result = $con->db->prepare($sql);
		$insert = $result->execute();
		return $insert;
	}

	public function guardarResponsable()
	{
		$con=Conexion::getInstance();
		$sql="INSERT INTO ins_per (codigo_ins_per, codigo_ins, cedula) VALUES (NULL,'$this->codigo_ins','$this->cedula')";
		$result = $con->db->prepare($sql);
		$insert = $result->execute();
		return $insert;
	}

	public function getIdIns()
	{
		$con = Conexion::getInstance();
		$sql="SELECT codigo_ins AS total FROM $this->tabla WHERE `nombre_ins`= '$this->nombre_ins'";
		$result = $con->db->prepare($sql);
		$result->execute();
		$data = $result->fetch()['total'];
		return $data;
	}

	public function modificarInstitucion($codigo_ins)
	{
		$con = Conexion::getInstance();
		$sql="UPDATE $this->tabla SET nombre_ins='$this->nombre_ins' WHERE codigo_ins=:codigo_ins";
		$result = $con->db->prepare($sql);
		$params = array ("codigo_ins"=>$codigo_ins);
		$cambio = $result->execute($params);
		return $cambio;
	}

	public function getAll()
	{
		$con = Conexion::getInstance();
		$sql = "SELECT * FROM $this->tabla ORDER BY nombre_ins ASC";
		$result = $con->db->prepare($sql);
		$result->execute();
		$data = $result->fetchAll();
		return $data;
	}

	public function getById($codigo_ins)
	{
		$con = Conexion::getInstance();
		$sql = "SELECT * FROM $this->tabla WHERE codigo_ins=:codigo_ins";
		$result = $con->db->prepare($sql);
		$params = array ("codigo_ins"=>$codigo_ins);
		$result->execute($params);
		$data = $result->fetchAll();
		return $data;
	}

	public function deleteById($codigo_ins)
	{
		$con = Conexion::getInstance();
		$sql = "DELETE FROM $this->tabla WHERE codigo_ins=:codigo_ins";
		$result = $con->db->prepare($sql);
		$params = array ("codigo_ins"=>$codigo_ins);
		$borra = $result->execute($params);
		return $borra;
	}

	public function getInstitucion($post_por_pagina)
	{
		$con = Conexion::getInstance();
		$inicio = (self::pagina_actual() > 1) ? self::pagina_actual() * $post_por_pagina - $post_por_pagina: 0;
		$sql = "SELECT SQL_CALC_FOUND_ROWS * FROM $this->tabla AS I INNER JOIN ins_per AS IP ON I.codigo_ins=IP.codigo_ins INNER JOIN persona AS P ON IP.cedula=P.cedula ORDER BY I.codigo_ins ASC LIMIT $inicio, $post_por_pagina";
		$result = $con->db->prepare($sql);
		$result->execute();
		$data = $result->fetchAll();
		return $data;
	}

	public function buscarInstitucion(){
		$con= Conexion::getInstance();
		$id= $_POST['busqueda'];
		$sql= 'SELECT * FROM institucion WHERE nombre_ins LIKE :doc';
		$stmt= $con->db->prepare($sql);
		$result= $stmt->execute(array(':doc'=>"%$id%"));
		$rows = $stmt->fetchAll(\PDO::FETCH_OBJ);
		return $rows;
	}

	public function buscar_responsable($cedula){
		$con = Conexion::getInstance();
		$sql = "SELECT * FROM persona WHERE cedula LIKE :ce LIMIT 5";
		$result = $con->db->prepare($sql);
		$result->execute(array(':ce' => "%$cedula%"));
		$data = $result->fetchAll();

		if(is_array($data)==true && count($data) == 0){
			echo "<div class='alert alert-warning'>No se han encontrado resultados para '<b>".$cedula."</b>'. registre un nuevo responsable <a href='personaview.php' target='_blank'><button class='btn btn-primary'><i class='fa fa-plus-circle'></i></button></a></div>";
		} 
		echo $data;
		//else{

		// 	$html="<table class='table table-bordered table-hover table-reponsive mt-5' id='tabla_buscar'>
		// 	<thead class='table-header-grou table-inverse bg-inverse'>
		// 	<th>Nº Cedula</th>
		// 	<th>Nombres</th>
		// 	<th>Apellidos</th>
		// 	<th>Telefono</th>
		// 	<th>accion</th>
		// 	</thead>";

		// 	$html.="<tbody>";
		// 	for ($i=0; $i < count($data); $i++) {

		// 		$nombre= $data[$i][18]." ".$data[$i][19];
		// 		$ape_a= $data[$i][20]." ".$data[$i][21];
		// 		$nombre_p= $data[$i][9]." ".$data[$i][10];
		// 		$ape_p= $data[$i][11]." ".$data[$i][12];
		// 		$html .= "<tr>
		// 		<td>".$data[$i][1]."</td>
		// 		<td>".$data[$i][2]."</td>
		// 		<td>".$data[$i][9]." ".$data[$i][10]."</td>
		// 		<td>".$data[$i][18]." ".$data[$i][19]."</td>
		// 		<td><button class='btn btn-success' onclick='obtener_certificado(".$data[$i][0].",".$data[$i][1].",&apos;".$data[$i][2]."&apos;,&apos;".$nombre_p."&apos;,&apos;".$ape_p."&apos;,&apos;".$nombre_a." ".$ape_a."&apos;);'> añadir</button></td>
		// 		</tr>";

		// 	}

		// 	$html.="</tbody>";
		// 	$html .= "</table>";

		// 	echo $html;
		// 	return $data;
		// }
	}

	public function Persona()
	{//Función para cargar la disciplina
		$con = Conexion::getInstance();
		$sql = "SELECT * FROM persona ORDER BY cedula";
		$result = $con->db->prepare($sql);
		$result->execute();
		$datos = $result->fetchAll();
		return $datos;		
	}

}
?>