<?php
require_once("../Modelo/Evento.php");
require_once("../Config/Conexion.php");

class Solicitud extends Evento 
{
	protected $numero_soli, $estatus, $motivo, $tipo, $fecha, $cantidad_per, $monto, $id_respon, $nom_respon, $tlf_respo, $beneficiarios;

	private $codigo_per_soli;
	private $codigo_soli_dep;

	public function __construct($tab)
	{
		ClaseBase::setTabla($tab);
	}

	public function setNumero_soli($numero_soli){
		$this->numero_soli=$numero_soli;
	}
	public function getNumero_soli(){
		return $this->numero_soli;
	}
	
	public function setEstatus($estatus){
		$this->estatus=$estatus;
	}
	public function getEstatus(){
		return $this->estatus;
	}
	public function setMotivo($motivo){
		$this->motivo=$motivo;
	}
	public function getMotivo(){
		return $this->motivo;
	}
	public function setTipo_soli($tipo_soli){
		$this->tipo_soli=$tipo_soli;
	}
	public function getTipo_soli(){
		return $this->tipo_soli;
	}
	public function setFecha($fecha){
		$this->fecha=$fecha;
	}
	public function getFecha(){
		return $this->fecha;
	}
	public function setCantidad_per($cantidad_per){
		$this->cantidad_per=$cantidad_per;
	}
	public function getCantidad_per(){
		return $this->cantidad_per;
	}
	public function setMonto($monto){
		$this->monto=$monto;
	}
	public function getMonto(){
		return $this->monto;
	}

	public function setId_respon($id_respon){
		$this->id_respon=$id_respon;
	}
	public function getId_respon(){
		return $this->id_respon;
	}

	public function setNom_respon($nom_respon){
		$this->nom_respon=$nom_respon;
	}
	public function getNom_respon(){
		return $this->nom_respon;
	}

	public function setTlf_respon($tlf_respon){
		$this->tlf_respon=$tlf_respon;
	}
	public function getTlf_respon(){
		return $this->tlf_respon;
	}

	public function setBeneficiarios($beneficiarios){
		$this->beneficiarios=$beneficiarios;
	}
	public function getBeneficiarios(){
		return $this->beneficiarios;
	}

	public function setCodigo_per_soli($codigo_per_soli){
		$this->codigo_per_solio=$codigo_per_soli;
	}

	public function setCodigo_soli_dep($codigo_soli_dep){
		$this->codigo_soli_dep=$codigo_soli_dep;
	}

	public function guardarSolicitud()
	{
		$con=Conexion::getInstance();
		$sql="INSERT INTO solicitud (`numero_soli`, `tipo_soli`, `estatus`, `fecha`, `motivo`, `monto`, `beneficiarios`, `cedula`) VALUES (NULL,'$this->tipo_soli','$this->estatus','$this->fecha','$this->motivo','$this->monto','$this->beneficiarios', '$this->cedula')";
		$result = $con->db->prepare($sql);
		$insert = $result->execute();
		return $insert;
	}

	public function guardarMatSoli()
	{
		$con=Conexion::getInstance();
		$sql="INSERT INTO `soli_deportiva`(`codigo_soli_dep`, `codigo_material`, `numero_soli`, `cantidadMaterial`) VALUES (NULL,'$this->codigo_material','$this->numero_soli','$this->cantidadMaterial')";
		echo $sql;
		$result = $con->db->prepare($sql);
		$insert = $result->execute();
		return $insert;
	}

	public function getIdSoli()
	{
		$con = Conexion::getInstance();
		$sql="SELECT numero_soli AS total FROM $this->tabla WHERE `fecha`= '$this->fecha' AND `motivo`='$this->motivo' AND `nom_respon`='$this->nom_respon' AND `monto`='$this->monto'";
		$result = $con->db->prepare($sql);
		$result->execute();
		$data = $result->fetch()['total'];
		return $data;
	}


	public function modificarSolicitud($numero_soli)
	{
		$con = Conexion::getInstance();
		$sql="UPDATE $this->tabla SET tipo_soli='$this->tipo_soli', estatus='$this->estatus', fecha='$this->fecha', motivo='$this->motivo', monto='$this->monto', nom_respon='$this->nom_respon' WHERE numero_soli=:numero_soli";
		$result = $con->db->prepare($sql);
		$params = array ("numero_soli"=>$numero_soli);
		$cambio = $result->execute($params);
		return $cambio;
	}

	public function solicitudesAprobadas()
	{
		$con = Conexion::getInstance();
		$sql="SELECT * FROM $this->tabla WHERE numero_soli NOT IN(SELECT id_cand FROM postulacion)";
		$result = $con->db->prepare($sql);
		$result->execute();
		$data = $result->fetchAll();
		return $data;
	}
	public function solicitudesEnproceso()
	{
		$con = Conexion::getInstance();
		$sql="SELECT * FROM $this->tabla WHERE numero_soli NOT IN(SELECT id_cand FROM postulacion)";
		$result = $con->db->prepare($sql);
		$result->execute();
		$data = $result->fetchAll();
		return $data;
	}

	public function solicitudesRechazadas()
	{
		$con = Conexion::getInstance();
		$sql="SELECT * FROM $this->tabla WHERE numero_soli NOT IN(SELECT id_cand FROM postulacion)";
		$result = $con->db->prepare($sql);
		$result->execute();
		$data = $result->fetchAll();
		return $data;
	}

	public function getAll()
	{
		$con = Conexion::getInstance();
		$sql = "SELECT * FROM $this->tabla ORDER BY numero_soli ASC";
		$result = $con->db->prepare($sql);
		$result->execute();
		$data = $result->fetchAll();
		return $data;
	}

	public function getById($numero_soli)
	{
		$con = Conexion::getInstance();
		$sql = "SELECT * FROM $this->tabla WHERE numero_soli=:numero_soli";
		$result = $con->db->prepare($sql);
		$params = array ("numero_soli"=>$numero_soli);
		$result->execute($params);
		$data = $result->fetchAll();
		return $data;
	}

	public function deleteById($numero_soli)
	{
		$con = Conexion::getInstance();
		$sql = "DELETE FROM $this->tabla WHERE numero_soli=:numero_soli";
		$result = $con->db->prepare($sql);
		$params = array ("numero_soli"=>$numero_soli);
		$borra = $result->execute($params);
		return $borra; 
	}

	public function getSolicitud($post_por_pagina)
	{
		$con = Conexion::getInstance();
		$inicio = (self::pagina_actual() > 1) ? self::pagina_actual() * $post_por_pagina - $post_por_pagina: 0;
		$sql = "SELECT SQL_CALC_FOUND_ROWS * FROM solicitud ORDER BY numero_soli ASC LIMIT $inicio, $post_por_pagina";
		$result = $con->db->prepare($sql);
		$result->execute();
		$data = $result->fetchAll();
		return $data;
	}

	public function anadirPersonas()
	{
		$con = Conexion::getInstance();
		$sql = "INSERT INTO persona_solicitud (codigo_per_soli, cedula, numero_soli) VALUES 
		(null,'$this->cedula','$this->numero_soli')";
		$result = $con->db->prepare($sql);
		$insert = $result->execute();
		return $insert;
	}

	public function Personas()
	{//Función para cargar la persona
		$con = Conexion::getInstance();
		$sql = "SELECT * FROM persona ORDER BY cedula";
		$result = $con->db->prepare($sql);
		$result->execute();
		$datos = $result->fetchAll();
		return $datos;		
	}	

	public function buscarSolicitud(){
		$con= Conexion::getInstance();
		$id= $_POST['busqueda'];
		$sql= 'SELECT * FROM solicitud WHERE nom_respon LIKE :doc';
		$stmt= $con->db->prepare($sql);
		$result= $stmt->execute(array(':doc'=>"%$id%"));
		$rows = $stmt->fetchAll(\PDO::FETCH_OBJ);
		return $rows;
	}

}
?>